//// Control ControlP5

public class ControlFrame extends PApplet {

  int w, h;
  int abc = 100;
  //  float fov, cameraZ;

  boolean saves = false;

  Accordion accordion;
  Bang saveb;
  Bang[] db;
  RadioButton rb;
  Slider thres;
  Slider[] sl;

  //  ColorPicker colp;

  public void setup() {
    size(w, h);
    frameRate(10);
    background(0);
    /*
    fov = PI/3.0;
     cameraZ = (height/2.0) / tan(fov/2.0);
     */


    cp5 = new ControlP5(this);
    setAccordion();
    //colp = cp5.addColorPicker("picker1").setBarHeight(5).removeProperty("picker1").setPosition(20, 120).setColorValue(cold[0]);
  }

  private void setAccordion() {

    dl = new DropdownList[12];
    db = new Bang[12];
    sl = new Slider[12];

    //cp5.addSlider("sliderA").plugTo(parent, "sliderA").setRange(0, 255).setPosition(25, 30);
    saveb = cp5.addBang("bang").plugTo(parent, "saves").setPosition(25, 20).setTriggerEvent(Bang.RELEASE).setLabel("savefiles");
    thres = cp5.addSlider("threshold").plugTo(parent, "threshold").setPosition(100, 20).setRange(0.1, 5).setValue(1);


    rb = cp5.addRadioButton("radioButton").setPosition(25, 70).setSize(40, 20).setColorForeground(color(120))
      .setColorActive(color(255))
        .setColorLabel(color(255))
          .setItemsPerRow(3)
            .setSpacingColumn(50)
              .addItem("4", 4)
                .addItem("8", 8)
                  .addItem("12", 12)
                    .activate(0)
                      ;

    for (Toggle t:rb.getItems()) {
      t.captionLabel().setColorBackground(color(255, 80));
      t.captionLabel().style().moveMargin(-7, 0, 0, -3);
      t.captionLabel().style().movePadding(7, 0, 0, 3);
      t.captionLabel().style().backgroundWidth = 45;
      t.captionLabel().style().backgroundHeight = 13;
    }

    ////set Group g1
    Group g1 = cp5.addGroup("InputColor4").setBackgroundColor(color(0, 64)).setBackgroundHeight(210);

    //// addDropdown
    dl[0] = cp5.addDropdownList("d1").setPosition(10, 70).setSize(100, 200).moveTo(g1);
    dl[1] = cp5.addDropdownList("d2").setPosition(120, 70).setSize(100, 200).moveTo(g1);
    dl[2] = cp5.addDropdownList("d3").setPosition(230, 70).setSize(100, 200).moveTo(g1);
    dl[3] = cp5.addDropdownList("d4").setPosition(340, 70).setSize(100, 200).moveTo(g1);
    customize(dl[0]);
    customize(dl[1]);
    customize(dl[2]);
    customize(dl[3]);

    dl[0].setIndex(95);
    dl[1].setIndex(96);
    dl[2].setIndex(97);
    dl[3].setIndex(94);

    db[0] = cp5.addBang("d1b").setPosition(10, 10).setSize(30, 20).moveTo(g1).setColorForeground(cold[0]);
    db[1] = cp5.addBang("d2b").setPosition(120, 10).setSize(30, 20).moveTo(g1).setColorForeground(cold[1]);
    db[2] = cp5.addBang("d3b").setPosition(230, 10).setSize(30, 20).moveTo(g1).setColorForeground(cold[2]);
    db[3] = cp5.addBang("d4b").setPosition(340, 10).setSize(30, 20).moveTo(g1).setColorForeground(cold[3]);

    sl[0] = cp5.addSlider("sl1").plugTo(parent, "ink0").setPosition(10, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g1);
    sl[1] = cp5.addSlider("sl2").plugTo(parent, "ink1").setPosition(120, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g1);
    sl[2] = cp5.addSlider("sl3").plugTo(parent, "ink2").setPosition(230, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g1);
    sl[3] = cp5.addSlider("sl4").plugTo(parent, "ink3").setPosition(340, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g1);


    ////set Group g2
    Group g2 = cp5.addGroup("InputColor8").setBackgroundColor(color(0, 64)).setBackgroundHeight(210);

    //// addDropdown
    dl[4] = cp5.addDropdownList("d5").setPosition(10, 70).setSize(100, 200).moveTo(g2);
    dl[5] = cp5.addDropdownList("d6").setPosition(120, 70).setSize(100, 200).moveTo(g2);
    dl[6] = cp5.addDropdownList("d7").setPosition(230, 70).setSize(100, 200).moveTo(g2);
    dl[7] = cp5.addDropdownList("d8").setPosition(340, 70).setSize(100, 200).moveTo(g2);
    customize(dl[4]);
    customize(dl[5]);
    customize(dl[6]);
    customize(dl[7]);

    db[4] = cp5.addBang("d5b").setPosition(10, 10).setSize(30, 20).moveTo(g2).setColorForeground(cold[4]);
    db[5] = cp5.addBang("d6b").setPosition(120, 10).setSize(30, 20).moveTo(g2).setColorForeground(cold[5]);
    db[6] = cp5.addBang("d7b").setPosition(230, 10).setSize(30, 20).moveTo(g2).setColorForeground(cold[6]);
    db[7] = cp5.addBang("d8b").setPosition(340, 10).setSize(30, 20).moveTo(g2).setColorForeground(cold[7]);

    sl[4] = cp5.addSlider("sl5").plugTo(parent, "ink4").setPosition(10, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g2);
    sl[5] = cp5.addSlider("sl6").plugTo(parent, "ink5").setPosition(120, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g2);
    sl[6] = cp5.addSlider("sl7").plugTo(parent, "ink6").setPosition(230, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g2);
    sl[7] = cp5.addSlider("sl8").plugTo(parent, "ink7").setPosition(340, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g2);

    ////set Group g3
    Group g3 = cp5.addGroup("InputColor12").setBackgroundColor(color(0, 64)).setBackgroundHeight(210);

    //// addDropdown
    dl[8] = cp5.addDropdownList("d9").setPosition(10, 70).setSize(100, 200).moveTo(g3);
    dl[9] = cp5.addDropdownList("d10").setPosition(120, 70).setSize(100, 200).moveTo(g3);
    dl[10] = cp5.addDropdownList("d11").setPosition(230, 70).setSize(100, 200).moveTo(g3);
    dl[11] = cp5.addDropdownList("d12").setPosition(340, 70).setSize(100, 200).moveTo(g3);
    customize(dl[8]);
    customize(dl[9]);
    customize(dl[10]);
    customize(dl[11]);

    db[8] = cp5.addBang("d9b").setPosition(10, 10).setSize(30, 20).moveTo(g3).setColorForeground(cold[8]);
    db[9] = cp5.addBang("d10b").setPosition(120, 10).setSize(30, 20).moveTo(g3).setColorForeground(cold[9]);
    db[10] = cp5.addBang("d11b").setPosition(230, 10).setSize(30, 20).moveTo(g3).setColorForeground(cold[10]);
    db[11] = cp5.addBang("d12b").setPosition(340, 10).setSize(30, 20).moveTo(g3).setColorForeground(cold[11]);

    sl[8] = cp5.addSlider("sl9").plugTo(parent, "ink8").setPosition(10, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g3);
    sl[9] = cp5.addSlider("sl10").plugTo(parent, "ink9").setPosition(120, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g3);
    sl[10] = cp5.addSlider("sl11").plugTo(parent, "ink10").setPosition(230, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g3);
    sl[11] = cp5.addSlider("sl12").plugTo(parent, "ink11").setPosition(340, 175).setSize(80, 15).setRange(2, 0.1).setValue(1).moveTo(g3);


    //// create a new accordion 
    accordion = cp5.addAccordion("acc").setPosition(25, 120).setWidth(450).addItem(g1).addItem(g2).addItem(g3); 
    accordion.open(0);

    //// use Accordion.MULTI to allow multiple group to be open at a time.
    accordion.setCollapseMode(Accordion.MULTI);
  }


  private void customize(DropdownList ddl) {

    ddl.setBackgroundColor(color(190));
    ddl.setItemHeight(15);
    ddl.setBarHeight(15);
    ddl.captionLabel().set("dropdown");
    ddl.captionLabel().style().marginTop = 3;
    ddl.captionLabel().style().marginLeft = 3;
    ddl.valueLabel().style().marginTop = 3;
    ddl.setHeight(100);
    ddl.addItems(dsname);   
    //ddl.scroll(0);
    ddl.setColorBackground(color(60));
    ddl.setColorActive(color(255, 128));
  }



  public void draw() {
    background(0);

    //// Color Chip Drawing
    for (int i = 0; i <paraNUM; i++) {
      db[i].setColorForeground(cold[i]);
    }

    //XYZgrapher();
  }

  private ControlFrame() {
  }

  public ControlFrame(Object theParent, int theWidth, int theHeight) {
    parent = theParent;
    w = theWidth;
    h = theHeight;
  }


  public ControlP5 control() {
    return cp5;
  }

  public void bang() {
    saves = true;
  }

  public void controlEvent(ControlEvent theEvent) {

    if (theEvent.isGroup()) {
      //// Color Input
      println("event from group : "+theEvent.getGroup().getValue()+" from "+theEvent.getGroup());
      int valueRow = int(theEvent.getGroup().getValue());
      println(valueRow);
      valueR = Integer.parseInt(data[valueRow][1]);
      valueG = Integer.parseInt(data[valueRow][2]);
      valueB = Integer.parseInt(data[valueRow][3]);

      for (int i = 0; i < paraNUM; i++) {

        if (theEvent.isFrom(dl[i])) {

          String stt = "d"+i+"d"+i;

          cold[i] = color(valueR, valueG, valueB, 255);
          //        colp.setColorValue(cold[0]);
          println(stt);
          println(valueR + "," + valueG +","+valueB);
        }
      }

      if (theEvent. isFrom(rb)) {

        useeNUM = int(theEvent.group().value());
        switch (useeNUM) {

        case 4:

          accordion.open(0).close(1, 2);
          break;

        case 8:

          accordion.open(0, 1).close(2);
          break;

        case 12:
          accordion.open(0, 1, 2);
          break;
        }
      }
    }


  }






  ControlP5 cp5;

  Object parent;
}

